use mdb;
set nocount on;

WITH Patch(install_pkg_uuid,sw_def_uuid,ipkg_name,status) As
(select install_pkg_uuid,sw_def_uuid,ipkg_name,status from ca_install_package where status in (3,9,11) AND ca_install_package.is_active=1
AND ca_install_package.sw_def_uuid NOT IN (select secondary_sw_def_uuid from ca_link_sw_def where link_type_id = 7)
AND ca_install_package.sw_def_uuid in (select sw_def_uuid from ca_software_signature where is_active = 1)),

Machine(host_name,asset_source_uuid) AS (select host_name,asset_source_uuid from ca_discovered_hardware),

Found_SW(sw_def_uuid,asset_source_uuid) AS (select sw_def_uuid,asset_source_uuid from ca_discovered_software),

Linkage(primary_sw_def_uuid,secondary_sw_def_uuid,link_type_id) AS (select primary_sw_def_uuid,secondary_sw_def_uuid,link_type_id from ca_link_sw_def),

Release(name,sw_def_uuid) AS (select name,sw_def_uuid from ca_software_def where software_type_id = 3 and sw_def_uuid in (select sw_def_uuid from ca_discovered_software)),

Requirement(name,sw_def_uuid) AS (select name,sw_def_uuid from ca_software_def where software_type_id = 3 and sw_def_uuid in (select sw_def_uuid from ca_discovered_software)),

tempresult (Host_Name,asset_source_uuid,Release,Patch,install_pkg_uuid,Patch_uuid,Patch_status) AS
(select distinct Machine.host_name,Machine.asset_source_uuid, Release.name as Release, Patch.ipkg_name as Patch, Patch.install_pkg_uuid as install_pkg_uuid, Patch.sw_def_uuid as Patch_uuid, Patch.status as status 
from Machine, Release, Patch, Linkage, Found_SW 
where Release.sw_def_uuid = Linkage.primary_sw_def_uuid and Patch.sw_def_uuid = Linkage.secondary_sw_def_uuid and 
Release.sw_def_uuid in (select primary_sw_def_uuid from Linkage where link_type_id=1 and Linkage.primary_sw_def_uuid in 
(select sw_def_uuid from Found_SW where Found_SW.asset_source_uuid=Machine.asset_source_uuid))
and Patch.sw_def_uuid Not In (Select sw_def_uuid from Found_SW where Found_SW.asset_source_uuid=Machine.asset_source_uuid)),

tempresult2 (Host_Name,asset_source_uuid,Release,Patch,install_pkg_uuid,Patch_uuid,Patch_status) AS
(select * from tempresult where asset_source_uuid in (select asset_source_uuid from Found_SW where sw_def_uuid in 
(select referenced_object_uuid from ca_requirement_spec_item where owner_object_uuid = install_pkg_uuid)))

select Host_Name,Release,Patch,Patch_status from tempresult2  order by Patch,Release,Host_Name;